#!/usr/local/bin/python2.7
'''Input and output.

Made by Andrew Uzilov for BME205, Fall 2011.
Email questions, concerns, etc. to:
auzilov@ucsc.edu
'''

import sys

print 'This goes to STDOUT.'
print >> sys.stderr, 'This goes to STDERR.'

outFile = open ('tmp.txt', 'w')
print >> outFile, 'This goes to a file.'
outFile.close()  # flush buffer to disk


### The many ways to load a file.

# Method #1: Slurp up all lines into a list.
# Pros: allows to jump around lines in any order.
# Cons: if file is large, can eat up lots of RAM.
print
print 'METHOD 1:'

inFile = open ('sample_data.bed', 'r')
lines = inFile.readlines()
print 'Line 15 is:\n', lines[14]

# Method #2: Use an iterator to loop over all lines.
# Pros: memory-efficient if you do it right.
# Cons: very little iteration control.
print
print 'METHOD 2:'

inFile = open ('sample_data.bed', 'r')
for line in inFile:
    fields = line.split()
    print 'Field 4 on this line is:', fields[3]

# Method #3: Use .readline() method to fetch one line at a time.
# Pros: full control over iteration; when combined with generators ('yield'
# keyword) in a function definition, you can make powerful parsers.
print
print 'METHOD 3:'

inFile = open ('sample_data.bed', 'r')
line1 = inFile.readline()
line2 = inFile.readline()
line3 = inFile.readline()

print 'Line 1 is:\n', line1
print 'Line 3 is:\n', line3

